/*************************************************************************/
/*                                                                       */
/*   Tone generator   */
/*                                                                       */
/*     STM32VL Discovery (STMicroelectronics, 24 MHz)                    */
/*                                                                       */
/*   NON COMMERCIAL USE ONLY                                             */
/*                                                                       */
/*   2011/5 Fujisekk LTD       (L)ym݌v                              */
/*  	MGG03420@nifty.ne.jp                                             */
/*   	http://www.d1.dion.ne.jp/~fujisekk                               */
/* 	   	http://homepage3.nifty.com/fujisekk                              */
/*                                                                       */
/*************************************************************************/
// #include <ST\iostm32f10x.h>

//#include <ST\iostm32f10xxB.h>
#include "tonegen.h"
#include "stm32f10x.h"
#include <math.h>

#ifdef syn_CV
volatile int spiq_wr_ix, spiq_rd_ix;
short wave_que[WAVEQUESIZE];
/* Copy from Hostio project Ti-DSP 5416 */

/*
 *  *  InitSineTable() - Initialize the sine wave table data
 *   */
#define PI               ((double)3.1415927)
void InitSineTable(void)
{
        int i;
        double increment= 0;
        double radian = 0;
double dw;
       increment = (PI * 2) / (double)64;
        for (i = 0; i < SINE_TABLE_SIZE; i++)
                {
//                   sinetable[i] = (int)((sin(radian)+1) * SINE_MAX);
                  dw=(sin(radian)+1) ;
                    sinetable[i] = (int)(dw * SINE_MAX);
                    radian += increment;
                }
}
#endif


void timer(unsigned long)  ;
void timer(unsigned long i) // ^C}[
{
  while(i--) ;
}  

/* CF Card sens & Write Protect sens */
int main(void)
{
unsigned long t;
unsigned int input;
//  RCC_APB2ENR |= 0x10;     // CPIOCgpł悤ɂB
  RCC_APB2ENR |= 0x14;     // CPIO A/Cgpł悤ɂB
  RCC_APB1ENR |= 0x20000010;     //Timer6,DACgpł悤ɂB
//  GPIOC_CRL = 0x43444444;   // PC6o͂ɂB@@
  GPIOC_CRH=0x44444433; // PC8/9o͂ɂ
  GPIOC_ODR = GPIOC_ODR&0xfeff;   // LED̏o͂OFF
stm32_port_setup();  
  wq_wr_ix = 0; // wave queue write index = 0
  wq_rd_ix = 0; // wave queue read  index = 0
// fill up wave queue with 0
//  for (i = 0; i < WAVEQUESIZE; i++) wave_que[i] = 0;
 InitSineTable(); // Generate Signe Data
  
/* copy from IWDG Project */
   /* Configure SysTick to generate an interrupt each 250ms */
 SysTick_Configuration();

 stm32_timer6_setup();
  /* Set SysTick interrupt vector Preemption Priority to 1 */
  NVIC_SetPriority(SysTick_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),1,0));
  NVIC_SetPriority(TIM6_DAC_IRQn, NVIC_EncodePriority(NVIC_GetPriorityGrouping(),1,0));
  stm32_timer6_start();
  while(1)
  {
      for(t=0; t < 0x1000; t++)
      {
        timer(100);
      }
      input=GPIOA_IDR;
	  if(!(input&0x0001)){
               GPIOC_ODR = GPIOC_ODR |0x100;    // LED̏o͂ON
	  }else{
            GPIOC_ODR = GPIOC_ODR&0xfeff;   // LED̏o͂OFF
          }
  }
}
